// file: lattice_path_constants.h
//
// this is the header for the path lattice_path class
//

// make sure definitions are only made once
//
#ifndef __ISIP_LATTICE_PATH_CONSTANTS
#define __ISIP_LATTICE_PATH_CONSTANTS

// isip include files
//
#ifndef __ISIP_INTEGRAL_CONSTANTS
#include <integral_constants.h>
#endif

// define the class name
//
#define LATTICE_PATH_CLASS_NAME (char_1*)"Lattice_path"

// define the lattice path types
//
#define LATTICE_PATH_CORRECT (int_4)0
#define LATTICE_PATH_INSERTION (int_4)1
#define LATTICE_PATH_DELETION (int_4)2
#define LATTICE_PATH_SUBSTITUTION (int_4)3
#define LATTICE_PATH_SKIP (int_4)4

// define the lattice path panalty scores
//
#define LATTICE_PATH_CORRECT_PENALTY (int_4)0
#define LATTICE_PATH_INSERTION_PENALTY (int_4)-3
#define LATTICE_PATH_DELETION_PENALTY (int_4)-3
#define LATTICE_PATH_SUBSTITUTION_PENALTY (int_4)-4
#define LATTICE_PATH_SKIP_PENALTY (int_4)0

// define some generic constants
//
#define LATTICE_PATH_DEFAULT_INDEX (int_4)-1
#define LATTICE_PATH_DEFAULT_SCORE (int_4)0

// end of file
// 
#endif
