// file: mm_grow_3.cc
//
 
// isip include files
//
#include "memory_manager.h"
#include "memory_manager_constants.h"

#include <lattice_node.h>

// method: grow_lat_cc
//
// arguments: none
//
// return: a logical_1 indicating success
//
// this method grows the number of empty lattice nodes by the lattice node
// grow size
//
logical_1 Memory_manager::grow_lat_cc() {

  // create new empty lattice nodes
  //
  Lattice_node** latn = new Lattice_node*[lat_grow_size_d];
  Link_node* lnd = (Link_node*)NULL;
  
  // insert the lattice nodes in a list
  //
  for (int_4 i = 0; i < lat_grow_size_d; i++) {
    lnd = new_node_cc();
    latn[i] = new Lattice_node();
    lnd->set_item_cc((void_p)latn[i]);
    if ((i == (int_4)0) && (lat_count_d == (int_4)0)) {
      lat_list_d = lnd;
    }
    else {
      lat_list_d->insert_cc(lnd);
    }
  }
  
  // update the count of free lats
  //
  lat_count_d += lat_grow_size_d;
  num_lat_d += lat_grow_size_d;

  // free pointer memory since the objects will be deleted seperately
  //
  delete [] latn;
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
