// file: mm_grow_4.cc
//
 
// isip include files
//
#include "memory_manager.h"
#include "memory_manager_constants.h"

#include <hash_cell.h>

// method: grow_hash_cc
//
// arguments: none
//
// return: a logical_1 indicating success
//
// this method grows the number of empty hash table cells by the hash
// table cell grow size
//
logical_1 Memory_manager::grow_hash_cc() {
  
  // create new empty hash table cells
  //
  Hash_cell** hcells = new Hash_cell*[hash_grow_size_d];
  Link_node* lnd = (Link_node*)NULL;
  
  // insert the hash table cells in a list
  //
  for (int_4 i = 0; i < hash_grow_size_d; i++) {
    lnd = new_node_cc();
    hcells[i] = new Hash_cell();
    lnd->set_item_cc((void_p)hcells[i]);
    if ((i == (int_4)0) && (hash_count_d == (int_4)0)) {
      hash_list_d = lnd;
    }
    else {
      hash_list_d->insert_cc(lnd);
    }
  }
  
  // update the count of free hashs
  //
  hash_count_d += hash_grow_size_d;
  num_hash_d += hash_grow_size_d;

  // free pointer memory since the objects will be deleted seperately
  //
  delete [] hcells;
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
