// file: mm_grow_8.cc
//
 
// isip include files
//
#include "memory_manager.h"
#include "memory_manager_constants.h"

#include <lattice_path.h>

// method: grow_lpath_cc
//
// arguments: none
//
// return: a logical_1 indicating success
//
// this method grows the number of empty lattice paths by the lattice path
// grow size
//
logical_1 Memory_manager::grow_lpath_cc() {

  // create new empty lattice paths
  //
  Lattice_path** lpth = new Lattice_path*[lpath_grow_size_d];
  Link_node* lnd = (Link_node*)NULL;
  
  // insert the lattice paths in a list
  //
  for (int_4 i = 0; i < lpath_grow_size_d; i++) {
    lnd = new_node_cc();
    lpth[i] = new Lattice_path();
    lnd->set_item_cc((void_p)lpth[i]);
    if ((i == (int_4)0) && (lpath_count_d == (int_4)0)) {
      lpath_list_d = lnd;
    }
    else {
      lpath_list_d->insert_cc(lnd);
    }
  }
  
  // update the count of free lats
  //
  lpath_count_d += lpath_grow_size_d;
  num_lpath_d += lpath_grow_size_d;

  // free pointer memory since the objects will be deleted seperately
  //
  delete [] lpth;
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
