// file: mod_hmm_0.cc
//

// isip include files
//
#include "model.h"
#include "model_constants.h"

// method: get_output_prob_cc
//
// arguments:
//  int_4 state : (input) the state index for which probability is reqd
//  float_4* data : (input) the acoustic data feature vector
//  int_4 frame : (input) the current frame index
//
// return: float_4 giving the output probability for the given observation
//
// this methods returns float_4 giving the observation probability for
// the specified state
//
float_4 Model::get_output_prob_cc(int_4 state_a, float_4* data_a,
				  int_4 frame_a) {

  // dummy variables
  //
  float_4 score = (float_4)0;

  // evaluate if appropriate
  //
  if ((state_a > (int_4)0) && (state_a < num_states_d)) {
    score = states_d[state_a]->eval_score_cc(data_a, frame_a);
  }
  
  // return the output probability
  //
  return score ;
}
