// file: spmtch_set_0.cc
//

// isip include files
//
#include "subpath_match.h"
#include "subpath_match_constants.h"

// method: set_start_time_cc
//
// arguments: an int_4 with the start time of the match
//  
// return: boolean indicating success
//
// this method sets the start time of a subpath match in a lattice
//
logical_1 Subpath_match::set_start_time_cc(int_4 start_time_a) {

  start_time_d = start_time_a;

  // exit gracefully
  //
  return ISIP_TRUE;
}

// method: set_end_time_cc
//
// arguments: an int_4 with the end time of the match
//  
// return: boolean indicating success
//
// this method sets the end time of a subpath match in a lattice
//
logical_1 Subpath_match::set_end_time_cc(int_4 end_time_a) {

  end_time_d = end_time_a;

  // exit gracefully
  //
  return ISIP_TRUE;

}

// method: set_score_cc
//
// arguments: a float_4 with the score of the match 
//  
// return: boolean indicating success
//
// this method sets the score of a subpath match in a lattice
//
logical_1 Subpath_match::set_score_cc(float_4 score_a) {

  score_d = score_a;

  // exit gracefully
  //
  return ISIP_TRUE;
}

// method: set_num_models_cc
//
// arguments: an int_4 the number of models in this subpath match 
//  
// return: boolean indicating success
//
// this method sets the number of acoustic models involved in this match
//
logical_1 Subpath_match::set_num_models_cc(int_4 num_models_a) {

  num_models_a = num_models_d;

  // exit gracefully
  //
  return ISIP_TRUE;
}

// method: set_start_time_pad_cc
//
// arguments: an int_4 with the start time padding used for match comparison 
//  
// return: boolean indicating success
//
// this method sets the start time padding which is used for comparing matches
//
logical_1 Subpath_match::set_start_time_pad_cc(int_4 start_time_pad_a) {

  start_time_pad_d = start_time_pad_a;

  // exit gracefully
  //
  return ISIP_TRUE;
}

// method: set_end_time_pad_cc
//
// arguments: an int_4 with the end time padding used for match comparison 
//  
// return: boolean indicating success
//
// this method sets the end time padding which is used for comparing matches
//
logical_1 Subpath_match::set_end_time_pad_cc(int_4 end_time_pad_a) {

  end_time_pad_d = end_time_pad_a;;

  // exit gracefully
  //
  return ISIP_TRUE;
}
