// file: tr_ht_debug_0.cc
//

// isip include files
//

#ifndef __ISIP_INTEGRAL_CONSTANTS_H
#include<integral_constants.h>
#endif

#include "train_hash_table.h"
#include "train_hash_table_constants.h"

// method: debug_cc
//
// arguments:
//  FILE* fp: (input) a open file pointer
//  char_1* message: (input) a message to be displayed
//
// return: a logical_1 flag indicating success
//
logical_1 Train_Hash_table::debug_cc(FILE *fp_a, char_1* message_a) {
  
  // dump the contents of the class to the file
  //
  fprintf(fp_a, "%s::%s size_d = %ld\n", TRAIN_HASH_TABLE_CLASS_NAME, message_a,
	  size_d);

  // print the mode
  //
  fprintf(fp_a, "%s::%s mode_d = %c\n", TRAIN_HASH_TABLE_CLASS_NAME, message_a,
	  mode_d);

  // dump the link node pointer information
  //
  fprintf(fp_a, "%s::%s Train_Hash_cells_d = %p\n", TRAIN_HASH_TABLE_CLASS_NAME, message_a,
	  cells_d);

  // for each cell
  //
  for (int_4 k = 0; k < size_d; k++) {
  
    // output the node list
    //
    for (Train_Hash_cell* cell = cells_d[k]; cell != (Train_Hash_cell*)NULL;
	 cell = cell->get_next_cc()) {
      cell->debug_cc(fp_a, message_a);
    }
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}






