// file: tr_st_set_4.cc
//

// isip include files
//
#include "train_state.h"
#include "train_state_constants.h"
 
// method: set_covar_cc
//
// arguments:
//  float_4** covar : (input) covar matrices
//
// return: a logical_1 indicating success
//
// this method sets the covar matrices for all mixture
//
logical_1 Train_State::set_covar_cc(float_4** covar_a) {

  // free existing memory
  //
  if (covar_d != (float_4**)NULL) {
    for (int_4 i = 0; i < num_mixtures_d; i++) {
      delete [] covar_d[i];
    }
    delete [] covar_d;
  }
  
  // allocate memory for covar and copy data
  //
  covar_d = new float_4*[num_mixtures_d];
  for (int_4 i = 0; i < num_mixtures_d; i++) {
    covar_d[i] = new float_4[num_features_d];
    memcpy(covar_d[i], covar_a[i], num_features_d * sizeof(float_4));
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
