// file: window/window_constants.h
//

// make sure definitions are made only once
//
#ifndef __ISIP_WINDOW_CONSTANTS
#define __ISIP_WINDOW_CONSTANTS

// isip include files
//
#ifndef __ISIP_INTEGRAL_CONSTANTS
#include <integral_constants.h>
#endif

// define the class name
//
#define WINDOW_CLASS_NAME (char_1*)"Window"

// define the types of windows
//
#define WIN_TYPE_UNKNOWN 0
#define WIN_TYPE_RECTANGLE 1
#define WIN_TYPE_HAMMING 2
#define WIN_TYPE_HANNING 3

#define WIN_OPT_RECTANGLE (char_1*)"rectangle"
#define WIN_OPT_HAMMING (char_1*)"hamming"
#define WIN_OPT_HANNING (char_1*)"hanning"

// define some mathematical window constants
//
#define WIN_HAMMING_COEFF (float_8)0.54
#define WIN_HANNING_COEFF (float_8)0.50

// end of file
//
#endif
