// file: ih_trans_0.cc
//

// isip include files
//
#include "init_hmm.h"
#include "init_hmm_constants.h"

// method: init_trans_cc
//
// arguments:
//  float_4*** trans : (output) the transtion metrixes
//  int_4 num_trans : (input) number of models
//  int_4* num_st : (input) the number of states in each model (exclude sp,
//                  s!, !s)
//
// return: a logical_1 flag indication success
//
logical_1 init_trans_cc(float_4*** trans_a, int_4 num_models_a,
			int_4* num_st_a) {

  // assign equiprobable transitions
  //
  for (int_4 i = 1; i < num_models_a; i++) {
    for (int_4 j = 0; j < num_st_a[i]-1; j++) {
      if (j == 0) {
	trans_a[i][j][j+1] = 1.0;
      }
      else {
	trans_a[i][j][j] = 0.5;
	trans_a[i][j][j+1] = 0.5;
      }
    }
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}



    
