// file: $ISIP_PROTO/util/normalize_features/normalize_features_constants.h
//

// Make sure this file is only included once
//
#ifndef __ISIP_NORMALIZE_FEATURES_CONSTANTS
#define __ISIP_NORMALIZE_FEATURES_CONSTANTS

// isip include files
//
#ifndef __ISIP_INTEGRAL_CONSTANTS
#include <integral_constants.h>
#endif

// define the help file
//
#define NF_HELP_FILE "$ISIP_PROTO/doc/normalize_features.help"

// define the command-line parameter flags
//
#define NF_OPT_HELP (char_1*)"-help"
#define NF_OPT_FILE_IN (char_1*)"-input"
#define NF_OPT_FILE_OUT (char_1*)"-output"
#define NF_OPT_IN_MODE (char_1*)"-input_mode"
#define NF_OPT_OUT_MODE (char_1*)"-output_mode"
#define NF_OPT_NUM_COEFFS (char_1*)"-num_coeffs"
#define NF_OPT_NUM_SUBTRACT (char_1*)"-num_subtract"
#define NF_OPT_NUM_DIV (char_1*)"-num_div"
#define NF_OPT_IO_MODE_ASCII (char_1*)"ascii"
#define NF_OPT_IO_MODE_BINA (char_1*)"binary"


// define the default parameter values
//
#define NF_DEF_NUM_COEFFS (int_4)39
#define NF_DEF_NUM_SUB (int_4)12
#define NF_DEF_NUM_DIV (int_4)39
#define NF_DEF_IN_MODE NF_IO_MODE_BINA
#define NF_DEF_OUT_MODE NF_IO_MODE_BINA

// define the input/output mode
//
#define NF_IO_MODE_ASCII (int_4)0
#define NF_IO_MODE_BINA (int_4)1

// end of file
//
#endif
